// Written by TeTeT
RUG_DSAI_TerminalDistance = -1;

h1 setVariable ["land", l1];
h2 setVariable ["land", l2];
h3 setVariable ["land", l3];
h4 setVariable ["land", l4];

[[h1, h2, h3, h4]] spawn {
	params ["_helos"];
	private _groups = [];

	{
		private _helo = _x;
		_helo setVariable ["start", getPos _helo];
		private _spawnPos = _x getPos [20, 180];
		private _grp = createGroup west;
		_groups pushBack _grp;
		{
			_grp createUnit [_x, _spawnPos, [], 10, "FORM"];
		} forEach ["uns_men_USMC_65_SL", "uns_men_USMC_65_RF1", "uns_men_USMC_65_RF2", "uns_men_USMC_65_RF3", "uns_men_USMC_65_RF4",
				   "uns_men_USMC_65_RF5", "uns_men_USMC_65_RF6", "uns_men_USMC_65_MED", "uns_men_USMC_65_RTO", "uns_men_USMC_65_HMG" ];
		_helo setVariable ["group", _grp];

	} forEach _helos;
	sleep 5;
	{
		private _helo = _x;
		private _grp = _helo getVariable "group";
		private _wp = _grp addWaypoint [getPos _helo, 0];
		_wp setWaypointSpeed "LIMITED";
		_wp setWaypointFormation "COLUMN";
		_wp setWaypointBehaviour "CARELESS";
		_wp setWaypointType "GETIN";
		{_x assignAsCargo _helo} forEach units _grp;
	} forEach _helos;
	sleep 10;
	// evil global
	[] spawn {
		waitUntil {h1 distance smokeLeader < 500};

		private _pos = getPos smokeLeader;
		private _smoke = "SmokeShellGreen" createVehicle _pos;
		_smoke setPos [_pos select 0, _pos select 1, 100];
		_smoke setDamage 1;
	};
	cnt = 0;
	groupsRally = 0;
	{
		[_x] spawn {
			params ["_helo"];
			private _grp = _helo getVariable "group";
			waitUntil {{alive _x} count (units _grp) == {_x in _helo} count (units _grp)};
			cnt = cnt + 1;
			waitUntil {{alive _x} count (units _grp) == {!(_x in _helo)} count (units _grp)};
			private _wp = _grp addWaypoint [getPos leader _grp, 30];
			_wp setWaypointFormation "DIAMOND";
			_wp setWaypointSpeed "LIMITED";
			_wp setWaypointBehaviour "SAFE";

			_wp = _grp addWaypoint [getPos rally, 50];
			_wp setWaypointFormation "COLUMN";
			_wp setWaypointSpeed "LIMITED";
			_wp setWaypointBehaviour "SAFE";
			waitUntil {leader _grp distance rally < 70};
			groupsRally = groupsRally + 1;
		};
	} forEach _helos;
	waitUntil {cnt == count _helos};
	// (units group smokeLeader) joinSilent (group player);

	{
		private _helo = _x;
		sleep random 5;
		_helo engineOn true;
		private _wp = (group driver _helo) addWaypoint [_helo getPos [500, 0], 0];
		_wp setWaypointSpeed "NORMAL";
		_wp setWaypointFormation "COLUMN";
		_wp setWaypointBehaviour "SAFE";
		_wp = (group driver _helo) addWaypoint [_helo getVariable "land", 0];
		_wp setWaypointType "TR UNLOAD";
		_wp = (group driver _helo) addWaypoint [_helo getVariable "start", 0];
		_wp setWaypointType "GETOUT";
	} forEach _helos;

	waitUntil {groupsRally == count _groups};
	[] spawn {
		[a1, assault, "", 200, 10, [10,30]] spawn BIS_fnc_fireSupport;
		[a2, assault, "", 200, 10, [10,30]] spawn BIS_fnc_fireSupport;
		[a3, assault, "", 200, 10, [10,30]] spawn BIS_fnc_fireSupport;
	};
	sleep 30;
	{
		private _route = selectRandom [Left, Center, Right];
		private _wp = _x addWaypoint [_route, 100];
		_wp setWaypointSpeed "LIMITED";
		_wp setWaypointType "MOVE";
		_wp setWaypointBehaviour "SAFE";

		_wp = _x addWaypoint [assault, 100];
		_wp setWaypointType "SAD";
		_wp setWaypointBehaviour "AWARE";
	} forEach _groups;

};